function love.load()
	screen = {
		width = 640,
		height = 480
	}
	love.graphics.setBackgroundColor(255, 255, 255)
	love.graphics.setIcon(love.graphics.newImage("icon.png"))
	splashes = {}
	counter = 0
	pause = .5
	modifier = 2
	stop = false
end

function love.update(dt)
	if not stop then
		dt = dt * modifier
		counter = counter + dt
		if counter > pause then
			counter = counter - pause
			newSplash()
			pause = math.random(1, 20) / 10
		end
		for i=#splashes, 1, -1 do
			splashes[i].scale = splashes[i].scale * (dt + 1)
			if splashes[i].scale > screen.width * 2 then
				table.remove(splashes, i)
			end
		end
	end
end

function love.draw()
	for i=#splashes, 1, -1 do
		love.graphics.setColor(splashes[i].color.r, splashes[i].color.g, splashes[i].color.b)
		love.graphics.setLineWidth(splashes[i].scale / 5)
		love.graphics.circle("line", splashes[i].position.x, splashes[i].position.y, splashes[i].scale)
	end
	love.graphics.setColor(0, 0, 0, 64)
	love.graphics.print(love.timer.getFPS() .. "\n" .. string.sub(modifier / 2, 1, 4) .. "x\n" .. #splashes, 4, 4)
end

function love.keypressed(key, unicode)
	if key == " " then
		stop = not stop
	elseif key == "return" then
		love.graphics.toggleFullscreen()
	elseif in_table(key, {"up","right","=","+","kp+"}) then
		modifier = modifier * 1.25
	elseif in_table(key, {"down","left","-","_","kp-"}) then
		modifier = modifier * .8
	else
		love.event.quit()
	end
end

function love.mousereleased(x, y, button)
	newSplash(x, y)
end

function newSplash(x, y)
	splashes[#splashes + 1] = {
		color = {
			r = math.random(1, 255),
			g = math.random(1, 255),
			b = math.random(1, 255)
		},
		position = {
			x = x or math.random(0, screen.width),
			y = y or math.random(0, screen.height)
		},
		scale = 1
	}
end

function in_table(k, t)
	for i=1, #t do
		if t[i] == k then 
			return true 
		end
	end
	return false
end